/* Copyright (c) 2003 - Charles Schmidt <cschmidt2@emich.edu> */

#ifndef __ISHZILLA_DEBUG_H__
#define __ISHZILLA_DEBUG_H__

#ifdef __cplusplus
extern "C" {
#endif	

#include <glib.h>

void ishzilla_debug_enter(const gchar *file,const gchar *func);
void ishzilla_debug_return(const gchar *file,const gchar *func,guint line);

#define D(fmt, args...) g_print(fmt,## args);
#define D_ENTER ishzilla_debug_enter(__FILE__,__FUNCTION__);
#define D_RETURN(x) \
{ \
	ishzilla_debug_return(__FILE__,__FUNCTION__,__LINE__); \
\
	return x; \
}

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif
