/* Copyright (c) 2003 - Charles Schmidt <cschmidt2@emich.edu> */

#ifndef __ISHZILLA_FILE_DIALOG_H__
#define __ISHZILLA_FILE_DIALOG_H__

#include <nsIFilePicker.h>
#include <nsCOMPtr.h>
#include <nsString.h>
#include <nsILocalFile.h>
#include <nsIDOMWindow.h>
#include <nsIDOMWindowInternal.h>

#include <gtk/gtkwidget.h>

#define I_FILE_DIALOG_CID \
 {0xc0209478, 0x4b4f, 0x4b94, {0x9a, 0xe9, 0xfa, 0x15, 0x95, 0x69, 0xdd, 0x18}}
#define I_FILE_DIALOG_CONTRACTID "@mozilla.org/filepicker;1"
#define I_FILE_DIALOG_CLASSNAME "Ishzilla File Picker"

class IshzillaFileDialog : public nsIFilePicker
{
	public:
		IshzillaFileDialog();
		virtual ~IshzillaFileDialog();

	 	NS_DECL_ISUPPORTS
		NS_DECL_NSIFILEPICKER
	private:
		GtkWidget * find_gtk_parent(nsIDOMWindow *window);
		NS_METHOD handle_file_picker_result(PRInt16 *retval);

		nsCOMPtr<nsIDOMWindow> my_parent;

		nsCString my_title;
		nsCString my_filter;
		nsCString my_default_string;

		nsCOMPtr<nsILocalFile> my_file;
		nsCOMPtr<nsILocalFile> my_directory;

		PRInt16 my_mode;

		GtkWidget *my_parent_widget;
		GtkWidget *my_file_selector;
};

#endif
