/* Copyright (c) 2003 - Charles Schmidt <cschmidt2@emich.edu> */

#ifndef __ISHZILLA_PROGRESS_DIALOG_H__
#define __ISHZILLA_PROGRESS_DIALOG_H__

#include <nsIProgressDialog.h>
#include <nsIWebProgressListener.h>
#include <nsIWebBrowserPersist.h>
#include <nsIMIMEInfo.h>
#include <nsIRequest.h>
#include <nsIObserver.h>
#include <nsWeakReference.h>
#include <nsILocalFile.h>
#include <nsIHelperAppLauncherDialog.h>
#include <nsIExternalHelperAppService.h>
#include <nsCExternalHandlerService.h>
#include <nsIDOMWindow.h>
#include <nsIURI.h>

#include "ishzilla-content-handler.h"

#include <gtk/gtkwidget.h>

#define I_PROGRESS_DIALOG_CID \
 {0xae265806, 0xe1cc, 0x466a, {0x8d, 0xa6, 0x42, 0xe3, 0x6d, 0x44, 0xf0, 0x17}}
#define I_PROGRESS_DIALOG_CONTRACTID "@mozilla.org/progressdialog;1"
#define I_PROGRESS_DIALOG_CLASSNAME "Ishzilla Download Progress Dialog"

class IshzillaProgressDialog : 	public nsIProgressDialog,
				public nsIWebProgressListener,
				public nsSupportsWeakReference
{
	public:
		IshzillaProgressDialog();
		virtual ~IshzillaProgressDialog();

		nsresult cancel(void);


	 	NS_DECL_ISUPPORTS
		NS_DECL_NSIWEBPROGRESSLISTENER
		NS_DECL_NSIPROGRESSDIALOG
		NS_DECL_NSIDOWNLOAD
	private:
		NS_METHOD construct_dialog(void);

		nsCOMPtr<nsIURI> my_uri;
		nsCOMPtr<nsIFile> my_file;
		PRInt64 my_time_download_started;
		nsCOMPtr<nsIWebBrowserPersist> my_persist;
		nsCOMPtr<nsIMIMEInfo> my_mime_info;
		DownloadAction my_action;
	
		nsCOMPtr<nsIDOMWindow> my_parent;
		nsCOMPtr<nsIHelperAppLauncher> my_launcher;
		nsCOMPtr<nsIRequest> my_request;
		nsCOMPtr<nsIObserver> my_observer;
	
		PRInt64 my_start_time;
		PRInt64 my_elapsed;
		PRInt32 my_percent_complete;
		PRInt64 my_last_update;
		PRInt32 my_interval;

		gboolean my_canceled;

		GtkWidget *my_dialog;
		GtkWidget *my_progress_bar;
		GtkWidget *my_status_label;
		GtkWidget *my_time_label;
		GtkWidget *my_percentage_label;
};

#endif
